<template>
    <div>
        <button class="button is-dark" @click="googleSignIn()">
            <i class="fab fa-google" style="margin-right: 1em;"/>
            Sign-in with Google
        </button>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapState } from 'vuex';
import * as firebase from 'firebase/app';


export default Vue.extend({
    props: {
        next: String,
    },
    methods: {
        googleSignIn() {
            const provider = new firebase.auth.GoogleAuthProvider();
            firebase.auth().signInWithPopup(provider).then((result) => {
                // Google Access Token
                //var token = result.credential.accessToken;
                // The signed-in user info.
                //var user = result.user;
                this.doLogin(result)
            }).catch(function(error) {
                // TODO: Handle Errors here.
                var errorCode = error.code;
                var errorMessage = error.message;
                // The email of the user's account used.
                var email = error.email;
                // The firebase.auth.AuthCredential type that was used.
                var credential = error.credential;
                // ...
            });

        },
        doLogin(response: any) {
            this.$store.dispatch('fetchUser', response.user);
            this.$router.push({ name: this.next })
        }
    },
    computed: {
        ...mapState(['user'])
    }
})
</script>